#pragma once

#pragma warning(disable:4996)
#pragma warning(disable:4267)
#pragma warning(disable:4018)
#pragma warning(disable:4101)

#include <vector>
#include <map>
#include <string>


struct CStudent
{
public:
    int m_idx;
    char m_name[64];
    char m_country[32];
    char m_city[64];
    int m_age;
    double m_mark_gpa;

    CStudent()
    {
        m_idx = 0;
        strcpy(m_name, "");
        strcpy(m_city, "");
        strcpy(m_country, "");
        m_age = 0;
        m_mark_gpa = 0.0;
    }
};

struct CStudents
{
    char m_fileName[1024];
    std::vector<CStudent> m_studList;
    std::map<int, std::vector<int> > m_ageIndex;
    std::map<double, std::vector<int> > m_gpaIndex;
    std::map<std::string, std::vector<int> > m_nameIndex;
    std::map<std::string, std::vector<int> > m_cityIndex;
    std::map<std::string, std::vector<int> > m_countryIndex;

    CStudents(const char *filename) 
    { 
        strcpy(m_fileName, filename);
        ReadRecords();
    }

    void SimulateRecords()
    {
        char name[24];
        char city[24];
        char country[24];
        int age;
        double gpa;

        static const char*arrCity[] = { "San Jose", "Iselin", "Madras", "New York", "Hyderabad", "Delhi", "Houston", "Seatle", "Wahsington", "Mumbai", "Pune", "Bangalore" };
        static const char*arrCountry[] = { "USA", "USA", "India", "USA", "India", "India", "USA",  "USA", "USA", "India", "India", "India" };

        CTime t = CTime::GetCurrentTime();
        srand(t.GetSecond());
        for(int i = 0; i < 250; i++)
        {
            CStudent s;

            s.m_name[0] = 'A' + (rand() % 26);
            s.m_name[1] = 'A' + (rand() % 26);
            s.m_name[2] = 'A' + (rand() % 26);
            s.m_name[3] = 'A' + (rand() % 26);
            s.m_name[4] = 'A' + (rand() % 26);
            s.m_name[5] = '\0';
            s.m_age = 15 + (rand() % 8);
            s.m_mark_gpa = 2 + (((rand() % 300)) / 100.0);
            int pos = (rand() % 11);
            strcpy(s.m_city, arrCity[pos]);
            strcpy(s.m_country, arrCountry[pos]);
            m_studList.push_back(s);
            WriteRecords(false);
        }
        ReadRecords();
    }

    void AddRecord(CStudent &s)
    {
        m_studList.push_back(s);
        WriteRecords();
    }

    void AddRecord(const char *name, int age, const char *country, char *city, double gpa)
    {
        CStudent s;
        strcpy(s.m_name,name);
        strcpy(s.m_city,city);
        strcpy(s.m_country,country);
        s.m_age = age;
        s.m_mark_gpa = gpa;
        m_studList.push_back(s);
        WriteRecords();
    }

    int ReadRecords()
    {
        FILE *istream = fopen(m_fileName, "rb");
     
        if (istream == 0)
            return false;

        m_studList.clear();
        m_ageIndex.clear();
        m_gpaIndex.clear();
        m_nameIndex.clear();
        m_cityIndex.clear();
        m_countryIndex.clear();

        char buf[4096];

        for(int i = 0; ; i++)
        {
            if(feof(istream))
                break;
            int nBytesRead = fread(buf, 1, sizeof(CStudent), istream);
            if(nBytesRead < sizeof(CStudent))
                break;
            CStudent s;
            char *p = reinterpret_cast<char*>(&s);
            memcpy(p, buf, sizeof(CStudent));
            m_studList.push_back(s);
            int pos = m_studList.size() - 1;

            m_ageIndex[s.m_age].push_back(pos);
            m_gpaIndex[s.m_mark_gpa].push_back(pos);
            m_nameIndex[s.m_name].push_back(pos);
            m_cityIndex[s.m_city].push_back(pos);
            m_countryIndex[s.m_country].push_back(pos);
        }
        
        fclose(istream);

        return m_studList.size();
    }

    int WriteRecords(bool bReload = true)
    {
        FILE *ostream = fopen(m_fileName, "wb");

        if (ostream == 0)
            return false;

        int nTotalRecordsWritten = 0;
        char buf[4096];
        for(int i = 0; i < m_studList.size(); i++)
        {
            const CStudent &s = m_studList[i];
            fwrite((const char*)&s, 1, sizeof(CStudent), ostream);
            nTotalRecordsWritten++;
        }

        fclose(ostream);

        if(bReload == true)
            ReadRecords();

        return nTotalRecordsWritten;
    }
};

extern CStudents theStudents; 
