// StudentEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "StudentInformationSystem.h"
#include "StudentEditDlg.h"


// CStudentEditDlg dialog

IMPLEMENT_DYNAMIC(CStudentEditDlg, CDialog)

CStudentEditDlg::CStudentEditDlg(CStudent &s, bool bEdit, CWnd* pParent /*=NULL*/)
	: CDialog(CStudentEditDlg::IDD, pParent)
    , m_student(s)
    , m_edit(bEdit)
    , m_name(_T(""))
    , m_age(0)
    , m_city(_T(""))
    , m_country(_T(""))
    , m_gpa(0)
{

}

CStudentEditDlg::~CStudentEditDlg()
{
}

void CStudentEditDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Text(pDX, IDC_EDIT1, m_name);
    DDX_Text(pDX, IDC_EDIT2, m_age);
    DDV_MinMaxInt(pDX, m_age, 0, 100);
    DDX_Text(pDX, IDC_EDIT3, m_city);
    DDX_Text(pDX, IDC_EDIT4, m_country);
    DDX_Text(pDX, IDC_EDIT5, m_gpa);
	DDV_MinMaxDouble(pDX, m_gpa, 0.0, 5.0);
}


BEGIN_MESSAGE_MAP(CStudentEditDlg, CDialog)
    ON_BN_CLICKED(IDOK, &CStudentEditDlg::OnBnClickedOk)
END_MESSAGE_MAP()


BOOL CStudentEditDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

    m_name = m_student.m_name;
    m_age = m_student.m_age;
    m_gpa = m_student.m_mark_gpa;
    m_city = m_student.m_city;
    m_country = m_student.m_country;

    if( m_edit == true)
        SetWindowText("Edit Student Information");
    else
        SetWindowText("Add Student Information");
    UpdateData(FALSE);

    return TRUE;
}


// CStudentEditDlg message handlers

void CStudentEditDlg::OnBnClickedOk()
{
    UpdateData(TRUE);

    strcpy(m_student.m_name, m_name);
    m_student.m_age = m_age;
    m_student.m_mark_gpa = m_gpa;
    strcpy(m_student.m_city, m_city);
    strcpy(m_student.m_country, m_country);

    OnOK();
}
